//----------------------------------------------------------------------------------
//		Wavelet Noise Reducer  By  BS
//		Version 0.01
//
//		$Log$
//		last mod $Id$
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <math.h>
#include "filter.h"
#include "simdemul.h"

//---------------------------------------------------------------------
//		錾
//---------------------------------------------------------------------
#define LV_MAX	5

#define ID_BUTTON_SET 40001

static const int RectStep = (4<<LV_MAX);
//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------
static int fixed_w = 0, fixed_h = 0;	// nxkނ2^n̔{ƂȂ摜TCY
static float *sbuf = NULL;				// EF[ubgEf[^i[̈
static float *tbuf = NULL;				// EF[ubgEꎞƗ̈
static int pofs = 0;					// I(0=Y,1=Cr,2=Cb)

static BOOL setbmode = FALSE;			// ݒ{^[h
static int threshold[3][LV_MAX*3];		// kޑΏۍől
static int cursel = 0;					// ݑIĂvf

typedef struct {
	FILTER				*fp;
	FILTER_PROC_INFO	*fpip;
} FILTER_PARAM;

typedef struct {
	HWND b_set;
} FILTER_DIALOG;

FILTER_DIALOG dialog;

//4P(32rbg)SSEpPx_萔
static const __m128 pfpd1 = {-1.586134342f  , -1.586134342f  , -1.586134342f  , -1.586134342f  };
static const __m128 pfud1 = {-0.05298011854f, -0.05298011854f, -0.05298011854f, -0.05298011854f};
static const __m128 pfpd2 = { 0.8829110762f ,  0.8829110762f ,  0.8829110762f ,  0.8829110762f };
static const __m128 pfud2 = { 0.4435068522f ,  0.4435068522f ,  0.4435068522f ,  0.4435068522f };
static const __m128 pipd1 = { 1.586134342f  ,  1.586134342f  ,  1.586134342f ,   1.586134342f  };
static const __m128 piud1 = { 0.05298011854f,  0.05298011854f,  0.05298011854f,  0.05298011854f};
static const __m128 pipd2 = {-0.8829110762f , -0.8829110762f , -0.8829110762f , -0.8829110762f };
static const __m128 piud2 = {-0.4435068522f , -0.4435068522f , -0.4435068522f , -0.4435068522f };
static const __m128 psc1 = {    1.149604398f,     1.149604398f,     1.149604398f,     1.149604398f};
static const __m128 psc2 = {1.f/1.149604398f, 1.f/1.149604398f, 1.f/1.149604398f, 1.f/1.149604398f};
static _MM_ALIGN16 const unsigned long PABSMASK[4]	 = {0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF, 0x7FFFFFFF};	// _Βlp}XN
static _MM_ALIGN16 const unsigned long PSGNMASK[4]	 = {0x80000000, 0x80000000, 0x80000000, 0x60000000};	// _p}XN

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	18												//	gbNo[̐
#if TRACK_N
TCHAR *track_name[]   = { "Sel", "Lv.0 H", "Lv.0 V", "Lv.0 D", "Lv.1 H", "Lv.1 V", "Lv.1 D", "Lv.2 H", "Lv.2 V", "Lv.2 D", "Lv.3 H", "Lv.3 V", "Lv.3 D", "Lv.4 H", "Lv.4 V", "Lv.4 D",  "Pos.X",  "Pos.Y"};	// gbNo[̖O
int   track_default[] = {     0,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 };	// gbNo[̏l
int   track_s[]       = {     0,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 ,       0 };	// gbNo[̉l
int   track_e[]       = {     2,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    4096 ,    1920 ,    1080 };	// gbNo[̏l
#endif

#define	CHECK_N	2												//	`FbN{bNX̐
#if CHECK_N
TCHAR *check_name[]   = { "ϊf[^\" , "I͈͕\"   };	// `FbN{bNX
int   check_default[] = {  0               ,  0               };	// ftHg
#endif

#define tCURSEL		0
#define tDISPX		16
#define tDISPY		17
#define cWDDISP		0
#define cSELMODE	1

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_WINDOW_SIZE ,	//	tB^̃tO
	320,552,					//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"WaveletBS",				//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
#if TRACK_N
	track_name,					// gbNo[̖OS
	track_default,				// gbNo[̏lS
	track_s,					// gbNo[̐l̉
	track_e,					// gbNo[̐l̏
#else
	NULL,						//	gbNo[̖OSւ̃|C^
	NULL,						//	gbNo[̏lSւ̃|C^
	NULL,						//	gbNo[̐l̉ (NULLȂS0`256)
	NULL,						//	gbNo[̐l̏ (NULLȂS0`256)
#endif
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
#if CHECK_N
	check_name,					//	`FbN{bNX̖OSւ̃|C^
	check_default,				//	`FbN{bNX̏lSւ̃|C^
#else
	NULL,						//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
#endif
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	func_init,					//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_exit,					//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_update,				//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_WndProc,				//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
#if defined(SSE41)
	"Wavelet Noise Reducer(SSE4.1) ver0.01 by BS",
#elif defined(SSSE3)
	"Wavelet Noise Reducer(SSSE3) ver0.01 by BS",
#elif defined(SSE3)
	"Wavelet Noise Reducer(SSE3) ver0.01 by BS",
#elif defined(SSE2)
	"Wavelet Noise Reducer(SSE2) ver0.01 by BS",
#endif
	//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

//---------------------------------------------------------------------
//		fobN֌W
//---------------------------------------------------------------------
#if defined(DEBUG)
#include <stdio.h>
#include <stdlib.h>
static LARGE_INTEGER prof_s[16], prof_e[16], pfreq;
static double prof_r[16];
// ԕ\
static void _perf_result(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	QueryPerformanceFrequency(&pfreq);
	HFONT hFont = CreateFont(16, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH|FF_MODERN,
		"lr SVbN" );

	char stmp[1024];
	for(int i=0;i<6;i++)
		prof_r[i] = (double)(prof_e[i].QuadPart-prof_s[i].QuadPart)/(double)pfreq.QuadPart;
	sprintf_s(stmp, sizeof(stmp), 
		" fixed_w:%d\n"
		" fixed_h:%d\n"
		" Extract:%1.5e\n"
		"     fwt:%1.5e\n"
		"    k:%1.5e\n"
		"     iwt:%1.5e\n"
		"  Reduct:%1.5e\n"
		"     all:%1.5e\n",
		fixed_w, fixed_h, prof_r[1], prof_r[2], prof_r[3], prof_r[4], prof_r[5], prof_r[0]);
	fp->exfunc->draw_text(fpip->ycp_edit, 48, 48, stmp, 255, 255, 255, 0,hFont, NULL, NULL);
	DeleteObject(hFont);
}
#endif
//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}
/*--------------------------------------------------------------------
*	o
*-------------------------------------------------------------------*/
static void Extract(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				 = ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	 = ((FILTER_PARAM *)param1)->fpip;

	int start = ( fpip->h *  thread_id    ) / thread_num;
	int end   = ( fpip->h * (thread_id+1) ) / thread_num;

	short *src = (short*)(fpip->ycp_edit) + pofs + start * fpip->max_w * 3;
	float *dst = sbuf + start * fixed_w;

	int wa = fpip->w&(~15);

	for(int y=start;y<end;y++){
		int x, j;
		for(x=0;x<wa;x+=16){
			__m128i r0, r1, r2, r3;
#if defined(SSE41)
			r0 = _mm_insert_epi16(r0, *(src   ), 0);
			r1 = _mm_insert_epi16(r1, *(src+12), 0);
			r2 = _mm_insert_epi16(r2, *(src+24), 0);
			r3 = _mm_insert_epi16(r3, *(src+36), 0);
			r0 = _mm_insert_epi16(r0, *(src+ 3), 1);
			r1 = _mm_insert_epi16(r1, *(src+15), 1);
			r2 = _mm_insert_epi16(r2, *(src+27), 1);
			r3 = _mm_insert_epi16(r3, *(src+39), 1);
			r0 = _mm_insert_epi16(r0, *(src+ 6), 2);
			r1 = _mm_insert_epi16(r1, *(src+18), 2);
			r2 = _mm_insert_epi16(r2, *(src+30), 2);
			r3 = _mm_insert_epi16(r3, *(src+42), 2);
			r0 = _mm_insert_epi16(r0, *(src+ 9), 3);
			r1 = _mm_insert_epi16(r1, *(src+21), 3);
			r2 = _mm_insert_epi16(r2, *(src+33), 3);
			r3 = _mm_insert_epi16(r3, *(src+45), 3);
			r0 = _mm_cvtepi16_epi32(r0);
			r1 = _mm_cvtepi16_epi32(r1);
			r2 = _mm_cvtepi16_epi32(r2);
			r3 = _mm_cvtepi16_epi32(r3);
			r0 = _mm_castps_si128(_mm_cvtepi32_ps(r0));
			r1 = _mm_castps_si128(_mm_cvtepi32_ps(r1));
			r2 = _mm_castps_si128(_mm_cvtepi32_ps(r2));
			r3 = _mm_castps_si128(_mm_cvtepi32_ps(r3));
			_mm_store_si128((__m128i*)(dst   ), r0);
			_mm_store_si128((__m128i*)(dst+ 4), r1);
			_mm_store_si128((__m128i*)(dst+ 8), r2);
			_mm_store_si128((__m128i*)(dst+12), r3);
#else
			__m128i r4, r5;
			r0 = _mm_insert_epi16(r0, *(src   ), 0);
			r1 = _mm_insert_epi16(r1, *(src+24), 0);
			r0 = _mm_insert_epi16(r0, *(src+ 3), 1);
			r1 = _mm_insert_epi16(r1, *(src+27), 1);
			r0 = _mm_insert_epi16(r0, *(src+ 6), 2);
			r1 = _mm_insert_epi16(r1, *(src+30), 2);
			r0 = _mm_insert_epi16(r0, *(src+ 9), 3);
			r1 = _mm_insert_epi16(r1, *(src+33), 3);
			r0 = _mm_insert_epi16(r0, *(src+12), 4);
			r1 = _mm_insert_epi16(r1, *(src+36), 4);
			r0 = _mm_insert_epi16(r0, *(src+15), 5);
			r1 = _mm_insert_epi16(r1, *(src+39), 5);
			r0 = _mm_insert_epi16(r0, *(src+18), 6);
			r1 = _mm_insert_epi16(r1, *(src+42), 6);
			r0 = _mm_insert_epi16(r0, *(src+21), 7);
			r1 = _mm_insert_epi16(r1, *(src+45), 7);
			r4 = _mm_setzero_si128();
			r5 = _mm_setzero_si128();
			r2 = r0;
			r3 = r1;
			r4 = _mm_cmpgt_epi16(r4, r0);
			r5 = _mm_cmpgt_epi16(r5, r1);
			r0 = _mm_unpacklo_epi16(r0, r4);
			r2 = _mm_unpackhi_epi16(r2, r4);
			r1 = _mm_unpacklo_epi16(r1, r5);
			r3 = _mm_unpackhi_epi16(r3, r5);
			r0 = _mm_castps_si128(_mm_cvtepi32_ps(r0));
			r2 = _mm_castps_si128(_mm_cvtepi32_ps(r2));
			r1 = _mm_castps_si128(_mm_cvtepi32_ps(r1));
			r3 = _mm_castps_si128(_mm_cvtepi32_ps(r3));
			_mm_store_si128((__m128i*)(dst   ), r0);
			_mm_store_si128((__m128i*)(dst+ 4), r2);
			_mm_store_si128((__m128i*)(dst+ 8), r1);
			_mm_store_si128((__m128i*)(dst+12), r3);
#endif
			src += 48;
			dst += 16;
		}
		for(;x<fpip->w;x++){
			*dst = (float)*src;
			src += 3;
			dst += 1;
		}
		// ʉE[
		for(j=6;x<fixed_w;x++,j+=3){
			*dst = *(src-j);
			dst += 1;
		}
		src += (fpip->max_w - fpip->w) * 3;
	}
	
	// ʉ[
	start = ( fixed_w *  thread_id    ) / thread_num;
	end   = ( fixed_w * (thread_id+1) ) / thread_num;

	for(int x=start;x<end;x++){
		src = (short*)(fpip->ycp_edit) + pofs + (x + (fpip->h - 2) * fpip->max_w) * 3;
		dst = sbuf + x + fixed_w * fpip->h;
		for(int y=fpip->h;y<fixed_h;y++){
			*dst = *src;
			src -= fpip->max_w * 3;
			dst += fixed_w;
		}
	}
}
/*--------------------------------------------------------------------
*	EF[ubgϊ()
*-------------------------------------------------------------------*/
static void fwt97_h(int thread_id,int thread_num,void *param1,void *param2)
{
	int lv = *(int*)param2;	// x

	int proc_w = fixed_w >> lv;
	int proc_h = fixed_h >> lv;

	int start = ( proc_h *  thread_id    ) / thread_num;
	int end   = ( proc_h * (thread_id+1) ) / thread_num;

	float *pptr = sbuf + fixed_w * start;

#if defined(SSE2)
	int n8  = proc_w&(~ 7);
	int n16 = proc_w&(~15);
	int hn = proc_w >> 1;
	int hn4 = hn&(~3);
	int hn4_1 = hn4;
	int hn8 = hn&(~7);
	int hn8_1 = hn8;
	
	if(hn4==hn)
		hn4_1 -= 4;
	if(hn8==hn)
		hn8_1 -= 8;

	float *t0 = tbuf + fixed_w * thread_id * 2;	// Even Buffer
	float *t1 = t0 + fixed_w;					// Odd Buffer

	for(int y=start;y<end;y++){
		int i, j;
		// Separete evne and odd.
		for(i=0,j=0;i<n16;i+=16,j+=8)
		{
			__m128 r0 = _mm_load_ps(pptr+i   );
			__m128 r2 = _mm_load_ps(pptr+i+ 4);
			__m128 r3 = _mm_load_ps(pptr+i+ 8);
			__m128 r5 = _mm_load_ps(pptr+i+12);
			__m128 r1 = r0;
			__m128 r4 = r3;
			r0 = _mm_shuffle_ps(r0, r2, _MM_SHUFFLE(2,0,2,0));
			r1 = _mm_shuffle_ps(r1, r2, _MM_SHUFFLE(3,1,3,1));
			r3 = _mm_shuffle_ps(r3, r5, _MM_SHUFFLE(2,0,2,0));
			r4 = _mm_shuffle_ps(r4, r5, _MM_SHUFFLE(3,1,3,1));
			_mm_store_ps(t0+j  , r0);
			_mm_store_ps(t1+j  , r1);
			_mm_store_ps(t0+j+4, r3);
			_mm_store_ps(t1+j+4, r4);
		}
		for(       ;i<n8 ;i+= 8,j+=4)
		{
			__m128 r0 = _mm_load_ps(pptr+i   );
			__m128 r2 = _mm_load_ps(pptr+i+ 4);
			__m128 r1 = r0;
			r0 = _mm_shuffle_ps(r0, r2, _MM_SHUFFLE(2,0,2,0));
			r1 = _mm_shuffle_ps(r1, r2, _MM_SHUFFLE(3,1,3,1));
			_mm_store_ps(t0+j, r0);
			_mm_store_ps(t1+j, r1);
		}
		for(     ;i<proc_w ;i+=2,j++)
		{
			t0[j] = pptr[i  ];
			t1[j] = pptr[i+1];
		}
		// Predict 1
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfpd1);
			r4 = _mm_mul_ps(r4, pfpd1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfpd1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += -1.586134342f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += -1.586134342f * 2.f * t0[hn-1];
		// Update 1
		t0[0] += -0.05298011854f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += -0.05298011854f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfud1);
			r4 = _mm_mul_ps(r4, pfud1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += -0.05298011854f * (t1[i-1] + t1[i  ]);
		// Predict 2
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfpd2);
			r4 = _mm_mul_ps(r4, pfpd2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfpd2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += 0.8829110762f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += 0.8829110762f * 2.f * t0[hn-1];
		// Update 2
		t0[0] += 0.4435068522f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += 0.4435068522f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfud2);
			r4 = _mm_mul_ps(r4, pfud2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += 0.4435068522f * (t1[i-1] + t1[i  ]);
		// Scale & Pack
		if(hn&3){
			for(i=0;i<hn8;i+=8)
			{
				__m128 r0 = _mm_load_ps(t0+i  );
				__m128 r1 = _mm_load_ps(t1+i  );
				__m128 r2 = _mm_load_ps(t0+i+4);
				__m128 r3 = _mm_load_ps(t1+i+4);
				r0 = _mm_mul_ps(r0, psc1);
				r1 = _mm_mul_ps(r1, psc2);
				r2 = _mm_mul_ps(r2, psc1);
				r3 = _mm_mul_ps(r3, psc2);
				_mm_store_ps(pptr+i     , r0);
				_mm_storeu_ps(pptr+i+hn  , r1);
				_mm_store_ps(pptr+i   +4, r2);
				_mm_storeu_ps(pptr+i+hn+4, r3);
			}
			for(   ;i<hn4;i+=4)
			{
				__m128 r0 = _mm_load_ps(t0+i  );
				__m128 r1 = _mm_load_ps(t1+i  );
				r0 = _mm_mul_ps(r0, psc1);
				r1 = _mm_mul_ps(r1, psc2);
				_mm_store_ps(pptr+i     , r0);
				_mm_storeu_ps(pptr+i+hn  , r1);
			}
			for(   ;i<hn;i++)
			{
				pptr[i   ] = t0[i] * (    1.149604398f);
				pptr[i+hn] = t1[i] * (1.f/1.149604398f);
			}
		}else{
			for(i=0;i<hn8;i+=8)
			{
				__m128 r0 = _mm_load_ps(t0+i  );
				__m128 r1 = _mm_load_ps(t1+i  );
				__m128 r2 = _mm_load_ps(t0+i+4);
				__m128 r3 = _mm_load_ps(t1+i+4);
				r0 = _mm_mul_ps(r0, psc1);
				r1 = _mm_mul_ps(r1, psc2);
				r2 = _mm_mul_ps(r2, psc1);
				r3 = _mm_mul_ps(r3, psc2);
				_mm_store_ps(pptr+i     , r0);
				_mm_store_ps(pptr+i+hn  , r1);
				_mm_store_ps(pptr+i   +4, r2);
				_mm_store_ps(pptr+i+hn+4, r3);
			}
			for(   ;i<hn4;i+=4)
			{
				__m128 r0 = _mm_load_ps(t0+i  );
				__m128 r1 = _mm_load_ps(t1+i  );
				r0 = _mm_mul_ps(r0, psc1);
				r1 = _mm_mul_ps(r1, psc2);
				_mm_store_ps(pptr+i     , r0);
				_mm_store_ps(pptr+i+hn  , r1);
			}
			for(   ;i<hn;i++)
			{
				pptr[i   ] = t0[i] * (    1.149604398f);
				pptr[i+hn] = t1[i] * (1.f/1.149604398f);
			}
		}
		pptr += fixed_w;
	}
#else
	float *tptr = tbuf + fixed_w * thread_id;
	for(int y=start;y<end;y++){
		int x;
		// Predict 1
		// (1..n-2)
		for (x=1;x<proc_w-2;x+=2){
			pptr[x] += -1.586134342f*(pptr[x-1]+pptr[x+1]);
		} 
		pptr[proc_w-1] += -1.586134342f*2.f*pptr[proc_w-2];
		// Update 1
		// (2..n-1)
		for (x=2;x<proc_w;x+=2){
			pptr[x] += -0.05298011854f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[0] += -0.05298011854f*2.f*pptr[1];
		// Predict 2
		for (x=1;x<proc_w-2;x+=2){
			pptr[x] += 0.8829110762f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[proc_w-1] += 0.8829110762f*2.f*pptr[proc_w-2];
		// Update 2
		for (x=2;x<proc_w;x+=2){
			pptr[x] += 0.4435068522f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[0] += 0.4435068522f*2.f*pptr[1];
		// Scale
		for (x=0;x<proc_w;x++){
			if(x%2)
				pptr[x] /= 1.149604398f;
			else
				pptr[x] *= 1.149604398f;
		}
		// Pack
		for (x=0;x<proc_w;x++){
			if(x%2==0)
				tptr[x/2] = pptr[x];
			else
				tptr[proc_w/2+x/2] = pptr[x];
		}
		for (x=0;x<proc_w;x++)
			pptr[x] = tptr[x];
		
		pptr += fixed_w;
	}
#endif
}
/*--------------------------------------------------------------------
*	EF[ubgϊ(c)
*-------------------------------------------------------------------*/
static void fwt97_v(int thread_id,int thread_num,void *param1,void *param2)
{
	int lv = *(int*)param2;	// x
	int proc_w = fixed_w >> lv;
	int proc_h = fixed_h >> lv;

	int start = ( proc_w *  thread_id    ) / thread_num;
	int end   = ( proc_w * (thread_id+1) ) / thread_num;

	if(proc_h&1)
		return;
	float *pptr = sbuf + start;
#if defined(SSE2)
	int n8  = proc_h&(~ 7);
	int n16 = proc_h&(~15);
	int hn = proc_h >> 1;
	int hn4 = hn&(~3);
	int hn4_1 = hn4;
	int hn8 = hn&(~7);
	int hn8_1 = hn8;
	
	if(hn4==hn)
		hn4_1 -= 4;
	if(hn8==hn)
		hn8_1 -= 8;

	float *t0 = tbuf + fixed_h * thread_id * 2;	// Even Buffer
	float *t1 = t0 + fixed_h;					// Odd Buffer

	int h_ofs = fixed_w * hn;

	for(int x=start;x<end;x++){
		int i, j;
		float *p = pptr;
		// Separete evne and odd.
		for(i=0,j=0;i<proc_h ;i+=2,j++)
		{
			t0[j] = *(p        );
			t1[j] = *(p+fixed_w);
			p += fixed_w * 2;
		}
		// Predict 1
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfpd1);
			r4 = _mm_mul_ps(r4, pfpd1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfpd1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += -1.586134342f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += -1.586134342f * 2.f * t0[hn-1];
		// Update 1
		t0[0] += -0.05298011854f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += -0.05298011854f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfud1);
			r4 = _mm_mul_ps(r4, pfud1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += -0.05298011854f * (t1[i-1] + t1[i  ]);
		// Predict 2
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfpd2);
			r4 = _mm_mul_ps(r4, pfpd2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfpd2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += 0.8829110762f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += 0.8829110762f * 2.f * t0[hn-1];
		// Update 2
		t0[0] += 0.4435068522f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += 0.4435068522f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pfud2);
			r4 = _mm_mul_ps(r4, pfud2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pfud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += 0.4435068522f * (t1[i-1] + t1[i  ]);
		// Scale & Pack
		p = pptr;
		for(i=0;i<hn;i++)
		{
			*(p      ) = t0[i] * (    1.149604398f);
			*(p+h_ofs) = t1[i] * (1.f/1.149604398f);
			p += fixed_w;
		}
		pptr ++;
	}
#else
	float *tptr = tbuf + fixed_h * thread_id;
	for(int x=start;x<end;x++){
		int y;
		float *p = pptr;
		// Copy to temp
		for (y=0;y<proc_h;y++){
			tptr[y] = *p;
			p += fixed_w;
		}
		// Predict 1
		// (1..n-2)
		for (y=1;y<proc_h-2;y+=2){
			tptr[y] += -1.586134342f*(tptr[y-1]+tptr[y+1]);
		} 
		tptr[proc_h-1] += -1.586134342f*2.f*tptr[proc_h-2];
		// Update 1
		// (2..n-1)
		for (y=2;y<proc_h;y+=2){
			tptr[y] += -0.05298011854f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[0] += -0.05298011854f*2.f*tptr[1];
		// Predict 2
		for (y=1;y<proc_h-2;y+=2){
			tptr[y] += 0.8829110762f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[proc_h-1] += 0.8829110762f*2.f*tptr[proc_h-2];
		// Update 2
		for (y=2;y<proc_h;y+=2){
			tptr[y] += 0.4435068522f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[0] += 0.4435068522f*2.f*tptr[1];
		// Scale
		for (y=0;y<proc_h;y++){
			if(y%2)
				tptr[y] /= 1.149604398f;
			else
				tptr[y] *= 1.149604398f;
		}
		// Pack
		for (y=0;y<proc_h;y++){
			if(y%2==0)
				*(pptr+(y/2         )*fixed_w) = tptr[y];
			else
				*(pptr+(y/2+proc_h/2)*fixed_w) = tptr[y];
		}
		
		pptr ++;
	}
#endif
}
/*--------------------------------------------------------------------
*	Ҍ
*-------------------------------------------------------------------*/
static void Reduct(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				 = ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	 = ((FILTER_PARAM *)param1)->fpip;

	int y_start = ( fpip->h *  thread_id    ) / thread_num;
	int y_end   = ( fpip->h * (thread_id+1) ) / thread_num;

	float *src = sbuf + y_start * fixed_w;
	short *dst = (short*)(fpip->ycp_edit) + *(int*)param2 + y_start * fpip->max_w * 3;

	int wa = fpip->w&(~15);

	for(int y=y_start;y<y_end;y++){
		int x;
		for(x=0;x<wa;x+=16){
			__m128 r0, r1, r2, r3;
			r0 = _mm_load_ps(src   );
			r1 = _mm_load_ps(src+ 4);
			r2 = _mm_load_ps(src+ 8);
			r3 = _mm_load_ps(src+12);
			r0 = _mm_castsi128_ps(_mm_cvtps_epi32(r0));
			r1 = _mm_castsi128_ps(_mm_cvtps_epi32(r1));
			r2 = _mm_castsi128_ps(_mm_cvtps_epi32(r2));
			r3 = _mm_castsi128_ps(_mm_cvtps_epi32(r3));
			*(dst   ) = _mm_extract_epi16(_mm_castps_si128(r0), 0);
			*(dst+12) = _mm_extract_epi16(_mm_castps_si128(r1), 0);
			*(dst+24) = _mm_extract_epi16(_mm_castps_si128(r2), 0);
			*(dst+36) = _mm_extract_epi16(_mm_castps_si128(r3), 0);
			*(dst+ 3) = _mm_extract_epi16(_mm_castps_si128(r0), 2);
			*(dst+15) = _mm_extract_epi16(_mm_castps_si128(r1), 2);
			*(dst+27) = _mm_extract_epi16(_mm_castps_si128(r2), 2);
			*(dst+39) = _mm_extract_epi16(_mm_castps_si128(r3), 2);
			*(dst+ 6) = _mm_extract_epi16(_mm_castps_si128(r0), 4);
			*(dst+18) = _mm_extract_epi16(_mm_castps_si128(r1), 4);
			*(dst+30) = _mm_extract_epi16(_mm_castps_si128(r2), 4);
			*(dst+42) = _mm_extract_epi16(_mm_castps_si128(r3), 4);
			*(dst+ 9) = _mm_extract_epi16(_mm_castps_si128(r0), 6);
			*(dst+21) = _mm_extract_epi16(_mm_castps_si128(r1), 6);
			*(dst+33) = _mm_extract_epi16(_mm_castps_si128(r2), 6);
			*(dst+45) = _mm_extract_epi16(_mm_castps_si128(r3), 6);
			src += 16;
			dst += 48;
		}
		for(;x<fpip->w;x++){
			*dst = (short)*src;
			src += 1;
			dst += 3;
		}
		src +=  fixed_w - fpip->w;
		dst += (fpip->max_w - fpip->w) * 3;
	}
}
/*--------------------------------------------------------------------
*	EF[ubgtϊ()
*-------------------------------------------------------------------*/
static void iwt97_h(int thread_id,int thread_num,void *param1,void *param2)
{
	int lv = *(int*)param2;	// x

	int proc_w = fixed_w >> lv;
	int proc_h = fixed_h >> lv;

	int start = ( proc_h *  thread_id    ) / thread_num;
	int end   = ( proc_h * (thread_id+1) ) / thread_num;

	float *pptr = sbuf + fixed_w * start;

#if defined(SSE2)
	int n8  = proc_w&(~ 7);
	int n16 = proc_w&(~15);
	int hn = proc_w >> 1;
	int hn4 = hn&(~3);
	int hn4_1 = hn4;
	int hn8 = hn&(~7);
	int hn8_1 = hn8;
	
	if(hn4==hn)
		hn4_1 -= 4;
	if(hn8==hn)
		hn8_1 -= 8;

	float *t0 = tbuf + fixed_w * thread_id * 2;	// Even Buffer
	float *t1 = t0 + fixed_w;					// Odd Buffer

	for(int y=start;y<end;y++){
		int i, j;

		// Unpack & Undo scale
		if(hn&3){
			for(i=0;i<hn8;i+=8)
			{
				__m128 r0 = _mm_load_ps(pptr+i     );
				__m128 r1 = _mm_lddqu_ps(pptr+i+hn  );
				__m128 r2 = _mm_load_ps(pptr+i   +4);
				__m128 r3 = _mm_lddqu_ps(pptr+i+hn+4);
				r0 = _mm_mul_ps(r0, psc2);
				r1 = _mm_mul_ps(r1, psc1);
				r2 = _mm_mul_ps(r2, psc2);
				r3 = _mm_mul_ps(r3, psc1);
				_mm_store_ps(t0+i  , r0);
				_mm_store_ps(t1+i  , r1);
				_mm_store_ps(t0+i+4, r2);
				_mm_store_ps(t1+i+4, r3);
			}
			for(   ;i<hn4;i+=4)
			{
				__m128 r0 = _mm_load_ps(pptr+i     );
				__m128 r1 = _mm_lddqu_ps(pptr+i+hn  );
				r0 = _mm_mul_ps(r0, psc2);
				r1 = _mm_mul_ps(r1, psc1);
				_mm_store_ps(t0+i  , r0);
				_mm_store_ps(t1+i  , r1);
			}
			for(   ;i<hn;i++)
			{
				t0[i] = pptr[i   ] * (1.f/1.149604398f);
				t1[i] = pptr[i+hn] * (    1.149604398f);
			}
		}else{
			for(i=0;i<hn8;i+=8)
			{
				__m128 r0 = _mm_load_ps(pptr+i     );
				__m128 r1 = _mm_load_ps(pptr+i+hn  );
				__m128 r2 = _mm_load_ps(pptr+i   +4);
				__m128 r3 = _mm_load_ps(pptr+i+hn+4);
				r0 = _mm_mul_ps(r0, psc2);
				r1 = _mm_mul_ps(r1, psc1);
				r2 = _mm_mul_ps(r2, psc2);
				r3 = _mm_mul_ps(r3, psc1);
				_mm_store_ps(t0+i  , r0);
				_mm_store_ps(t1+i  , r1);
				_mm_store_ps(t0+i+4, r2);
				_mm_store_ps(t1+i+4, r3);
			}
			for(   ;i<hn4;i+=4)
			{
				__m128 r0 = _mm_load_ps(pptr+i     );
				__m128 r1 = _mm_load_ps(pptr+i+hn  );
				r0 = _mm_mul_ps(r0, psc2);
				r1 = _mm_mul_ps(r1, psc1);
				_mm_store_ps(t0+i  , r0);
				_mm_store_ps(t1+i  , r1);
			}
			for(   ;i<hn;i++)
			{
				t0[i] = pptr[i   ] * (1.f/1.149604398f);
				t1[i] = pptr[i+hn] * (    1.149604398f);
			}
		}
		// Undo update 2
		t0[0] += -0.4435068522f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += -0.4435068522f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, piud2);
			r4 = _mm_mul_ps(r4, piud2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += -0.4435068522f * (t1[i-1] + t1[i  ]);
		// Undo predict 2
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pipd2);
			r4 = _mm_mul_ps(r4, pipd2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pipd2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += -0.8829110762f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += -0.8829110762f * 2.f * t0[hn-1];
		// Undo update 1
		t0[0] += 0.05298011854f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += 0.05298011854f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, piud1);
			r4 = _mm_mul_ps(r4, piud1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += 0.05298011854f * (t1[i-1] + t1[i  ]);
		// Undo predict 1
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pipd1);
			r4 = _mm_mul_ps(r4, pipd1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pipd1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += 1.586134342f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += 1.586134342f * 2.f * t0[hn-1];
		// Mix evne and odd.
		for(i=0,j=0;i<n16;i+=16,j+=8)
		{
			__m128 r0 = _mm_stream_load_ps(t0+j  );
			__m128 r2 = _mm_stream_load_ps(t1+j  );
			__m128 r3 = _mm_stream_load_ps(t0+j+4);
			__m128 r5 = _mm_stream_load_ps(t1+j+4);
			__m128 r1 = r0;
			__m128 r4 = r3;
			r0 = _mm_unpacklo_ps(r0, r2);
			r1 = _mm_unpackhi_ps(r1, r2);
			r3 = _mm_unpacklo_ps(r3, r5);
			r4 = _mm_unpackhi_ps(r4, r5);
			_mm_store_ps(pptr+i   , r0);
			_mm_store_ps(pptr+i+ 4, r1);
			_mm_store_ps(pptr+i+ 8, r3);
			_mm_store_ps(pptr+i+12, r4);
		}
		for(       ;i<n8 ;i+= 8,j+=4)
		{
			__m128 r0 = _mm_stream_load_ps(t0+j  );
			__m128 r2 = _mm_stream_load_ps(t1+j  );
			__m128 r1 = r0;
			r0 = _mm_unpacklo_ps(r0, r2);
			r1 = _mm_unpackhi_ps(r1, r2);
			_mm_store_ps(pptr+i   , r0);
			_mm_store_ps(pptr+i+ 4, r1);
		}
		for(     ;i<proc_w ;i+=2,j++)
		{
			pptr[i  ] = t0[j];
			pptr[i+1] = t1[j];
		}
		pptr += fixed_w;
	}
#else
	float *tptr = tbuf + fixed_w * thread_id;
	for(int y=start;y<end;y++){
		int x;

		// Unpack
		for (x=0;x<proc_w/2;x++){
				tptr[x*2  ] = pptr[x         ];
				tptr[x*2+1] = pptr[x+proc_w/2];
		}
		for (x=0;x<proc_w;x++)
			pptr[x] = tptr[x];

		// Undo scale
		for (x=0;x<proc_w;x++){
			if(x%2)
				pptr[x] *= 1.149604398f;
			else
				pptr[x] /= 1.149604398f;
		}
		// Undo update 2
		for (x=2;x<proc_w;x+=2){
			pptr[x] += -0.4435068522f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[0] += -0.4435068522f*2.f*pptr[1];
		// Undo predict 2
		for (x=1;x<proc_w-2;x+=2){
			pptr[x] += -0.8829110762f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[proc_w-1] += -0.8829110762f*2.f*pptr[proc_w-2];
		// Undo update 1
		// (2..n-1)
		for (x=2;x<proc_w;x+=2){
			pptr[x] += 0.05298011854f*(pptr[x-1]+pptr[x+1]);
		}
		pptr[0] += 0.05298011854f*2.f*pptr[1];
		// Undo predict 1
		// (1..n-2)
		for (x=1;x<proc_w-2;x+=2){
			pptr[x] += 1.586134342f*(pptr[x-1]+pptr[x+1]);
		} 
		pptr[proc_w-1] += 1.586134342f*2.f*pptr[proc_w-2];

		pptr += fixed_w;
	}
#endif
}
/*--------------------------------------------------------------------
*	EF[ubgtϊ(c)
*-------------------------------------------------------------------*/
static void iwt97_v(int thread_id,int thread_num,void *param1,void *param2)
{
	int lv = *(int*)param2;	// x
	int proc_w = fixed_w >> lv;
	int proc_h = fixed_h >> lv;

	int start = ( proc_w *  thread_id    ) / thread_num;
	int end   = ( proc_w * (thread_id+1) ) / thread_num;

	if(proc_h&1)
		return;
	float *pptr = sbuf + start;
#if defined(SSE2)
	int n8  = proc_h&(~ 7);
	int n16 = proc_h&(~15);
	int hn = proc_h >> 1;
	int hn4 = hn&(~3);
	int hn4_1 = hn4;
	int hn8 = hn&(~7);
	int hn8_1 = hn8;
	
	if(hn4==hn)
		hn4_1 -= 4;
	if(hn8==hn)
		hn8_1 -= 8;

	float *t0 = tbuf + fixed_h * thread_id * 2;	// Even Buffer
	float *t1 = t0 + fixed_h;					// Odd Buffer

	int h_ofs = fixed_w * hn;

	for(int x=start;x<end;x++){
		int i, j;
		float *p = pptr;
		// Unpack & Undo scale
		for(i=0;i<hn;i++)
		{
			t0[i] = *(p      ) * (1.f/1.149604398f);
			t1[i] = *(p+h_ofs) * (    1.149604398f);
			p += fixed_w;
		}
		// Undo update
		t0[0] += -0.4435068522f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += -0.4435068522f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, piud2);
			r4 = _mm_mul_ps(r4, piud2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += -0.4435068522f * (t1[i-1] + t1[i  ]);
		// Undo predict 2
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pipd2);
			r4 = _mm_mul_ps(r4, pipd2);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pipd2);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += -0.8829110762f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += -0.8829110762f * 2.f * t0[hn-1];
		// Undo update 1
		t0[0] += 0.05298011854f * 2.f * t1[0];
		for(i=1;i<4&&i<hn4;i++)
			t0[i] += 0.05298011854f * (t1[i-1] + t1[i  ]);
		for(   ;i<8&&i<hn8;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn8;i+=8)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			__m128 r3 = _mm_load_ps (t0+i+4);
			__m128 r4 = _mm_lddqu_ps(t1+i+3);
			__m128 r5 = _mm_load_ps (t1+i+4);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, piud1);
			r4 = _mm_mul_ps(r4, piud1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t0+i  , r0);
			_mm_store_ps(t0+i+4, r3);
		}
		for(   ;i<hn4;i+=4)
		{
			__m128 r0 = _mm_load_ps (t0+i  );
			__m128 r1 = _mm_lddqu_ps(t1+i-1);
			__m128 r2 = _mm_load_ps (t1+i  );
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, piud1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t0+i  , r0);
		}
		for(   ;i<hn      ;i++)
			t0[i] += 0.05298011854f * (t1[i-1] + t1[i  ]);
		// Undo predict 1
		for(i=0;i<hn8_1;i+=8)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			__m128 r3 = _mm_load_ps (t1+i+4);
			__m128 r4 = _mm_load_ps (t0+i+4);
			__m128 r5 = _mm_lddqu_ps(t0+i+5);
			r1 = _mm_add_ps(r1, r2);
			r4 = _mm_add_ps(r4, r5);
			r1 = _mm_mul_ps(r1, pipd1);
			r4 = _mm_mul_ps(r4, pipd1);
			r0 = _mm_add_ps(r0, r1);
			r3 = _mm_add_ps(r3, r4);
			_mm_store_ps(t1+i  , r0);
			_mm_store_ps(t1+i+4, r3);
		}
		for(   ;i<hn4_1;i+=4)
		{
			__m128 r0 = _mm_load_ps (t1+i  );
			__m128 r1 = _mm_load_ps (t0+i  );
			__m128 r2 = _mm_lddqu_ps(t0+i+1);
			r1 = _mm_add_ps(r1, r2);
			r1 = _mm_mul_ps(r1, pipd1);
			r0 = _mm_add_ps(r0, r1);
			_mm_store_ps(t1+i  , r0);
		}
		for(   ;i<hn-1;i++)
			t1[i] += 1.586134342f * (t0[i  ] + t0[i+1]);
		t1[hn-1] += 1.586134342f * 2.f * t0[hn-1];
		// Mix evne and odd.
		p = pptr;
		for(i=0;i<hn ;i++)
		{
			*(p        ) = t0[i];
			*(p+fixed_w) = t1[i];
			p += fixed_w * 2;
		}
		pptr ++;
	}
#else
	float *tptr = tbuf + fixed_h * thread_id;
	for(int x=start;x<end;x++){
		int y;
		float *p = pptr;
		// Unpack
		for (y=0;y<proc_h/2;y++){
				tptr[y*2  ] = *(pptr+(y         )*fixed_w);
				tptr[y*2+1] = *(pptr+(y+proc_h/2)*fixed_w);
		}
		// Undo scale
		for (y=0;y<proc_h;y++){
			if(y%2)
				tptr[y] *= 1.149604398f;
			else
				tptr[y] /= 1.149604398f;
		}
		// Undo update 
		for (y=2;y<proc_h;y+=2){
			tptr[y] += -0.4435068522f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[0] += -0.4435068522f*2.f*tptr[1];
		// Undo predict 2
		for (y=1;y<proc_h-2;y+=2){
			tptr[y] += -0.8829110762f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[proc_h-1] += -0.8829110762f*2.f*tptr[proc_h-2];
		// Undo update 1
		// (2..n-1)
		for (y=2;y<proc_h;y+=2){
			tptr[y] += 0.05298011854f*(tptr[y-1]+tptr[y+1]);
		}
		tptr[0] += 0.05298011854f*2.f*tptr[1];
		// Undo predict 1
		// (1..n-2)
		for (y=1;y<proc_h-2;y+=2){
			tptr[y] += 1.586134342f*(tptr[y-1]+tptr[y+1]);
		} 
		tptr[proc_h-1] += 1.586134342f*2.f*tptr[proc_h-2];
		// Copy back to source
		for (y=0;y<proc_h;y++){
			*p = tptr[y];
			p += fixed_w;
		}
		pptr ++;
	}
#endif
}
/*--------------------------------------------------------------------
*	EF[ubgk
*-------------------------------------------------------------------*/
static void Degeneracy(int thread_id,int thread_num,void *param1,void *param2)
{
	int lvmax = *(int*)param2;
	
	for(int i=0;i<lvmax;i++){
		int proc_w = fixed_w >> (i+1);
		int proc_h = fixed_h >> (i+1);
	
		int start = ( proc_h *  thread_id    ) / thread_num;
		int end   = ( proc_h * (thread_id+1) ) / thread_num;
		
		float thres0, thres1;
		float *p;
		
		if(threshold[pofs][  i*3]){
			thres0 = (float)(threshold[pofs][  i*3])/4.f;
			p = sbuf + proc_w + start * fixed_w;
			for(int y=start;y<end;y++){
				for(int x=0;x<proc_w;x++){
					if(fabs(*p)<thres0)
						*p = 0.f;
						p ++;
				}
				p += fixed_w - proc_w;
			}
		}
		p = sbuf + (start + proc_h) * fixed_w;
		thres0 = (float)(threshold[pofs][1+i*3])/4.f;
		thres1 = (float)(threshold[pofs][2+i*3])/4.f;
		for(int y=start;y<end;y++){
			if(threshold[pofs][1+i*3]){
				for(int x=0;x<proc_w;x++){
					if(fabs(*p)<thres0)
						*p = 0.f;
						p ++;
				}
			}else
				p += proc_w;
			if(threshold[pofs][2+i*3]){
				for(int x=0;x<proc_w;x++){
					if(fabs(*p)<thres1)
						*p = 0.f;
						p ++;
				}
			}else
				p += proc_w;
			p += fixed_w - proc_w * 2;
		}
	}
}
//---------------------------------------------------------------------
//	EF[ubgϊf[^\
//---------------------------------------------------------------------
static void draw_wvd(FILTER *fp, FILTER_PROC_INFO *fpip, int lv)
{
	float fdp_last = 1.f/pow(2.f, (float)(lv));
	for(int i=0;i<lv;i++){
		int proc_w = fixed_w >> (i+1);
		int proc_h = fixed_h >> (i+1);
		
		float *src = sbuf;
		PIXEL_YC *dst = fpip->ycp_edit;
		float fdp = 256.f / pow(2.f, (float)(i));
		
		for(int y=0;y<proc_h*2;y++){
			for(int x=0;x<proc_w*2;x++){
				if(x<proc_w&&y<proc_h){
					if(i==lv-1){
						float f = fabs(*src);
						dst->y = f * fdp_last;
					}
				}else{
					float f = fabs(*src);
					dst->y = f * fdp;
				}
				dst->cr = 0;
				dst->cb = 0;
				src ++;
				dst ++;
			}
			src += fixed_w - (proc_w*2);
			dst += fpip->max_w - (proc_w*2);
		}
	}
}
//---------------------------------------------------------------------
//	mCYőlo
//---------------------------------------------------------------------
static void SetThreshold(FILTER *fp, int lv)
{
	for(int i=0;i<lv;i++){
		int proc_w = fixed_w >> (i+1);
		int proc_h = fixed_h >> (i+1);
	
		int grain = 1 << (i+1);
	
		int sx = (fp->track[tDISPX] + grain - 1) >> (i+1);
		int sy = (fp->track[tDISPY] + grain - 1) >> (i+1);
		int ex = (fp->track[tDISPX] + RectStep ) >> (i+1);
		int ey = (fp->track[tDISPY] + RectStep ) >> (i+1);
		
		float *p;
		float minv;
		
		// H Area
		p = sbuf + (sx + proc_w)+ sy * fixed_w;
		minv = 0.f;
		for(int y=sy;y<ey;y++){
			for(int x=sx;x<ex;x++){
				float f = fabs(*p);
				if(minv<f)
					minv = f;
				p ++;
			}
			p += (fixed_w - ex + sx);
		}
		threshold[pofs][i*3  ] = (int)(minv * 4.f);
		// V Area
		p = sbuf + sx + (sy + proc_h)* fixed_w;
		minv = 0.f;
		for(int y=sy;y<ey;y++){
			for(int x=sx;x<ex;x++){
				float f = fabs(*p);
				if(minv<f)
					minv = f;
				p ++;
			}
			p += (fixed_w - ex + sx);
		}
		threshold[pofs][i*3+1] = (int)(minv * 4.f);
		// D Area
		p = sbuf + (sx + proc_w) + (sy + proc_h)* fixed_w;
		minv = 0.f;
		for(int y=sy;y<ey;y++){
			for(int x=sx;x<ex;x++){
				float f = fabs(*p);
				if(minv<f)
					minv = f;
				p ++;
			}
			p += (fixed_w - ex + sx);
		}
		threshold[pofs][i*3+2] = (int)(minv * 4.f);
	}
}
//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp )
{
	for(int i=0;i<LV_MAX*3;i++){
		fp->track[1+i] = threshold[cursel][i];
	}
	fp->exfunc->filter_window_update(fp);
	return TRUE;
}
//---------------------------------------------------------------------
//		tB^ݒύX֐
//---------------------------------------------------------------------
BOOL func_update( FILTER *fp, int status )
{
	// ZN^ύX
	if(fp->track[tCURSEL]!=cursel){
		for(int i=0;i<LV_MAX*3;i++){
			threshold[cursel][i] = fp->track[1+i];
		}
		cursel = fp->track[tCURSEL];
		for(int i=0;i<LV_MAX*3;i++){
			fp->track[1+i] = threshold[cursel][i];
		}
		fp->exfunc->filter_window_update(fp);
	}
	return TRUE;
}
//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	int lv =LV_MAX;
	int lvmax = 1<<lv;
	BOOL eMode = fp->exfunc->is_editing(fp);
	
	// mCYTv̈ Wőlݒ
/*
	track_s[tDISPX] = lvmax + 1;
	track_s[tDISPY] = lvmax + 1;
	if(fp->track[tDISPX]<track_s[tDISPX]){
		fp->track[tDISPX] = track_s[tDISPX];
		fp->exfunc->filter_window_update(fp);
	}
	if(fp->track[tDISPY]<track_s[tDISPY]){
		fp->track[tDISPY] = track_s[tDISPY];
		fp->exfunc->filter_window_update(fp);
	}
*/
	track_e[tDISPX] = ((fpip->w)&(~(lvmax-1))) - RectStep - 1;
	track_e[tDISPY] = ((fpip->h)&(~(lvmax-1))) - RectStep - 1;
	if(fp->track[tDISPX]>track_e[tDISPX]){
		fp->track[tDISPX] = track_e[tDISPX];
		fp->exfunc->filter_window_update(fp);
	}
	if(fp->track[tDISPY]>track_e[tDISPY]){
		fp->track[tDISPY] = track_e[tDISPY];
		fp->exfunc->filter_window_update(fp);
	}
	
	
	// ݕ\Ă鐧lǂݍ
	for(int i=0;i<LV_MAX*3;i++){
		threshold[cursel][i] = fp->track[1+i];
	}

	// nxΉTCYvZ
	fixed_w = (fpip->w+(lvmax-1))&(~(lvmax-1));
	fixed_h = (fpip->h+(lvmax-1))&(~(lvmax-1));

	// ycp_temp̃TCYsꍇ͂ȂɂȂ
	if(fixed_w * fixed_h * 4 > fpip->max_w * fpip->max_h * 6)
		return FALSE;
	
	// 16oCgACg␳ςݍƗ̈m
	sbuf = (float*)(((unsigned long)(fpip->ycp_temp)+15)&(~15));
	tbuf = sbuf + fixed_w * fixed_h;

	FILTER_PARAM filter_param = {fp, fpip};

	pofs = 0;	// YI
	if(fp->check[cWDDISP]&&pofs!=fp->track[tCURSEL]&&eMode)
		goto ProcCr;
	// o
	fp->exfunc->exec_multi_thread_func(Extract, &filter_param, &pofs);
	// EF[ubgϊ
	for(int i=0;i<lv;i++){
		fp->exfunc->exec_multi_thread_func(fwt97_h, &filter_param, &i);
		fp->exfunc->exec_multi_thread_func(fwt97_v, &filter_param, &i);
	}
	// mCYőlo
	if(fp->check[cSELMODE]&&setbmode)
		SetThreshold(fp, lv);
	fp->exfunc->exec_multi_thread_func(Degeneracy, &filter_param, &lv);
	if(fp->check[cWDDISP]&&pofs==fp->track[tCURSEL]&&eMode){
		draw_wvd(fp, fpip, lv);
		return TRUE;
	}else{
		// EF[ubgtϊ
		for(int i=lv-1;i>=0;i--){
			fp->exfunc->exec_multi_thread_func(iwt97_v, &filter_param, &i);
			fp->exfunc->exec_multi_thread_func(iwt97_h, &filter_param, &i);
		}
		// Ҍ
		fp->exfunc->exec_multi_thread_func(Reduct, &filter_param, &pofs);
	}
	
ProcCr:
	pofs = 1;	// CrI
	if(fp->check[cWDDISP]&&pofs!=fp->track[tCURSEL]&&eMode)
		goto ProcCb;
	// o
	fp->exfunc->exec_multi_thread_func(Extract, &filter_param, &pofs);
	// EF[ubgϊ
	for(int i=0;i<lv;i++){
		fp->exfunc->exec_multi_thread_func(fwt97_h, &filter_param, &i);
		fp->exfunc->exec_multi_thread_func(fwt97_v, &filter_param, &i);
	}
	// mCYőlo
	if(fp->check[cSELMODE]&&setbmode)
		SetThreshold(fp, lv);
	fp->exfunc->exec_multi_thread_func(Degeneracy, &filter_param, &lv);
	if(fp->check[cWDDISP]&&pofs==fp->track[tCURSEL]&&eMode){
		draw_wvd(fp, fpip, lv);
		return TRUE;
	}else{
		// EF[ubgtϊ
		for(int i=lv-1;i>=0;i--){
			fp->exfunc->exec_multi_thread_func(iwt97_v, &filter_param, &i);
			fp->exfunc->exec_multi_thread_func(iwt97_h, &filter_param, &i);
		}
		// Ҍ
		fp->exfunc->exec_multi_thread_func(Reduct, &filter_param, &pofs);
	}

ProcCb:
	pofs = 2;	// CbI
	if(fp->check[cWDDISP]&&pofs!=fp->track[tCURSEL]&&eMode)
		return TRUE;
	// o
	fp->exfunc->exec_multi_thread_func(Extract, &filter_param, &pofs);
	// EF[ubgϊ
	for(int i=0;i<lv;i++){
		fp->exfunc->exec_multi_thread_func(fwt97_h, &filter_param, &i);
		fp->exfunc->exec_multi_thread_func(fwt97_v, &filter_param, &i);
	}
	// mCYőlo
	if(fp->check[cSELMODE]&&setbmode){
		SetThreshold(fp, lv);
		for(int i=0;i<LV_MAX*3;i++){
			fp->track[1+i] = threshold[fp->track[tCURSEL]][i];
		}
		setbmode == FALSE;
		fp->exfunc->filter_window_update(fp);
	}
	fp->exfunc->exec_multi_thread_func(Degeneracy, &filter_param, &lv);
	if(fp->check[cWDDISP]&&pofs==fp->track[tCURSEL]&&eMode){
		draw_wvd(fp, fpip, lv);
		return TRUE;
	}else{
		// EF[ubgtϊ
		for(int i=lv-1;i>=0;i--){
			fp->exfunc->exec_multi_thread_func(iwt97_v, &filter_param, &i);
			fp->exfunc->exec_multi_thread_func(iwt97_h, &filter_param, &i);
		}
		// Ҍ
		fp->exfunc->exec_multi_thread_func(Reduct, &filter_param, &pofs);
	}

	// mCYTv̈ g\
	if(fp->check[cSELMODE]&&eMode){
		PIXEL_YC *p = fpip->ycp_edit + fp->track[tDISPX] + fp->track[tDISPY] * fpip->max_w;
		for(int x=0;x<RectStep;x++)
			(p+x)->y = 4095 - (p+x)->y;
		p += fpip->max_w;
		for(int y=1;y<RectStep-1;y++){
			p->y = 4095 - p->y;
			(p+RectStep-1)->y = 4095 - (p+RectStep-1)->y;
			p += fpip->max_w;
		}
		for(int x=0;x<RectStep;x++)
			(p+x)->y = 4095 - (p+x)->y;
	}
	
	return TRUE;
}
//---------------------------------------------------------------------
//		Window֐
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	SYS_INFO si;
	if(fp->exfunc->get_sys_info)
		fp->exfunc->get_sys_info(editp, &si);
	switch(message){
		case WM_FILTER_INIT:
			dialog.b_set = CreateWindow(TEXT("BUTTON"), TEXT("ݒ"), WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_VCENTER,
				8, 488, 304, 32, hwnd, (HMENU)ID_BUTTON_SET, fp->dll_hinst, NULL);
			SendMessage(dialog.b_set, WM_SETFONT, (WPARAM)si.hfont, 0);
			//track_s[tDISPX] = (1<<LV_MAX) + 1;
			//track_s[tDISPY] = (1<<LV_MAX) + 1;
			track_e[tDISPX] = ((si.max_w)&(~(1<<LV_MAX))) - RectStep - 1;
			track_e[tDISPY] = ((si.max_h)&(~(1<<LV_MAX))) - RectStep - 1;
			fp->exfunc->filter_window_update(fp);
			return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wparam)){
				case ID_BUTTON_SET:
					setbmode = TRUE;
					SendMessage(dialog.b_set, WM_KILLFOCUS,0,0);
					break;
				default:
					setbmode = FALSE;
					return FALSE;
			}
			return fp->exfunc->is_filter_active(fp);
		case WM_FILTER_EXIT:
			break;
		case WM_KEYUP:
		case WM_KEYDOWN:
		case WM_MOUSEWHEEL:
			SendMessage(GetWindow(hwnd, GW_OWNER), message, wparam, lparam);
			break;
	}
	
	UNREFERENCED_PARAMETER(editp);
	UNREFERENCED_PARAMETER(lparam);
	
	return FALSE;
}
//---------------------------------------------------------------------
//		tB^I֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
	return TRUE;
}
